clear all;
close all;
clc;


%% Lecture de la vido

vid=vision.VideoFileReader('v1.mp4');

%% Dtection de la composante rouge de l'image

% Masque pour la fonction imclose (voir help strel)
se=strel('disk',10);

% Acquisition, traitement & affichage
while ~isDone(vid)
    
    % Etraction d'une image dans le flux vido
    RGB=step(vid);
    RGB=uint8(255.0*double(RGB));
    im_rgb=imresize(RGB,[256 256]);
    
    % Rcuprer la composante R
    im_gray=rgb2gray(im_rgb);
    im_R=im_rgb(:,:,1);
    
    % Calcul de l'image rsultante
    im_r=imsubtract(im_R,im_gray);
    
    % Seuillage de l'image (binrisation)
    %     rr=sort(im_r(:));
    %     val=mean(rr(end-150:end))
    r_min=40;
    val=abs(max(double(im_r(:)))-r_min);
    
    seuil=val/255;  % Seuil de l'image (variable)
    seuil_fixe=100;    % Seuil minimal fixe ( Problme absence de la couleur cible)
    im_bw=im2bw(im_r,seuil);
    im_bw1=im_bw & (im_r >seuil_fixe);
    im_out=imclose(im_bw1,se);
    
    % Dtecter le primtre d'une rgion (NG +Primtre)
    im_line=bwperim(im_out);
    im_out1=im_rgb(:,:,2);
    im_out1(im_line)=255;
    
    % RGB + Primtre
    im_out2=im_rgb;
    im_out2(:,:,2)=im_out1;
    
    % RGB + Rgion
    im_out3=im_rgb;
    im_30=find(im_out==1);
    im_out3(im_30)=0;
    
    % Calcul pourcentage de la couleur rouge dans l'image
    taille_red=length(find(im_out(:)==1));
    taille_im=length(im_out(:));
    Red_perc=100*taille_red/taille_im
    
    %% Affichage
    figure(1)
    % imshow(im_out);
    % imshow(im_out1);
    subplot(121); imagesc(im_out2);
    subplot(122); imagesc(im_out3);
end
