close all;
clc;


%% Ouverture du port srie

SerialCOM = Open(); % A commenter aprs la 1re excution

%% Cration de l'objet vido

vid=videoinput('winvideo',1);
set(vid,'ReturnedColorSpace','RGB');

%% Dtection de la composante rouge dans l'iimage

while 1
    
    % Obtenir l'image actuelle
    imm=getsnapshot(vid);
    im_rgb=imresize(imm,[512 512]);
    
    % Rcuprer la composante R
    im_gray=rgb2gray(im_rgb);
    im_R=im_rgb(:,:,1);
    im_r=imsubtract(im_R,im_gray);
    
    %% Seuillage de l'image (binrisation)
    %     rr=sort(im_r(:));
    %     val=mean(rr(end-150:end))
    val=abs(max(double(im_r(:)))-20);
    
    seuil=val/255;  % Seuil de l'image (variable)
    Red_min=80;     % Seuil minimal fix ( Problme du  l'absence de la couleur cible)
    im_bw=im2bw(im_r,seuil);
    im_bw1=im_bw & (im_r >Red_min);
    se=strel('disk',10);
    im_out=imclose(im_bw1,se);
    
    %% Add line
    im_line=bwperim(im_out);
    im_out1=im_rgb(:,:,2);
    im_out1(im_out)=255; % im_line
    im_out2=im_rgb;
    im_out2(:,:,2)=im_out1;
    
    %% Activation de la LED
    
    % Nombre des pixels de la couleur rouge
    taille_red=length(find(im_out(:)==1));
    
    % Activation de la LED par pourcentage (0.5%) ( trs dpendant de
    % la taille de l'image)
    taille_im=length(im_out(:));
    Red_perc=100*taille_red/taille_im;
    LED1=double(Red_perc>0.5);
    
    % Activation de la LED par le nombre de pixel (indpendant de
    % la taille de l'image)
    Seuil_detec=100;
    LED2=double(taille_red>Seuil_detec);
    
    %% Centre de gravit
    figure(1)
    imshow(im_rgb);
    s = regionprops(im_out, im_gray, {'Centroid','WeightedCentroid'});
    title('Weighted (red) and Unweighted (blue) Centroids');
    hold on
    numObj = numel(s);
    for k = 1 : numObj
        plot(s(k).WeightedCentroid(1), s(k).WeightedCentroid(2), 'r*');
        plot(s(k).Centroid(1), s(k).Centroid(2), 'bo');
    end
    hold off;
    
    
    %% Affichage
    
    %     figure(2)
    %     subplot(221); imshow(im_rgb)
    %     subplot(222); imshow(im_r);
    %     subplot(223); imshow(im_out);
    %     subplot(224); imshow(im_out2);
    
    %% Transmission  l'Arduino
    
    % L'tat des deux dtecteurs
    LED=[LED1 LED2]
    
    % Transmission des donnes
    Startt='#';     % Caractre de dbut de Tx
    Endd='*';       % Caractre de fin de Tx
    WriteData(LED,Startt,Endd, SerialCOM); % Transmission de donnes
end

%% Port Delete (Previous port if exist)

Delete(SerialCOM); % A executer seule pour lberer le port


